#ifndef BASIC_CRITTERS_H
#define BASIC_CRITTERS_H

#include "CreatureAddon.h"
#include "Creature.h"

// player

class Player : public Creature
{
	public:
		Player( Dungeon * );
		virtual ~Player();
		
		virtual void Attack( Creature * );
};

class PlayerInfo : public CreatureInfo
{
	public:
		PlayerInfo();
		
		virtual Creature * Create( Dungeon * );

	protected:
		bitmap_info		bmp[2];
};

// orc

class Orc : public Creature
{
	public:
		Orc( Dungeon * );
		virtual ~Orc();
		
		virtual void AI();
		virtual void Death();
		virtual void Attack( Creature * );

};

class OrcInfo : public CreatureInfo
{
	public:
		OrcInfo();
		
		virtual Creature * Create( Dungeon * );
		virtual bool ShouldPlace( int );

	protected:
		bitmap_info		bmp[2];
};

// rat

class Rat : public Creature
{
	public:
		Rat( Dungeon * );
		virtual ~Rat();
		
		virtual void AI();
		virtual void Death();
		virtual void Damage( damage );
		virtual void Attack( Creature * );

	protected:
		uint32	target;
		bool	irritated;
};

class RatInfo : public CreatureInfo
{
	public:
		RatInfo();
		
		virtual Creature * Create( Dungeon * );
		virtual bool ShouldPlace( int );

	protected:
		bitmap_info		bmp[2];
};

// builder

class BasicBuilder : public CreatureBuilder
{
	public:
		BasicBuilder();
		
		virtual Creature * Create( Dungeon *, const char * name );

	protected:
		PlayerInfo		player_info;
		OrcInfo			orc_info;
		RatInfo			rat_info;

		CreatureInfo 	* info_original[3];
};

#endif
